IFDEF VOCAB:
VOCAB: EXTENSIONS
EXTENSIONS
}
P2 TACHYON
IFDEF EXTEND.fth
	FORGET EXTEND.fth
}

	pub EXTEND.fth		." TACHYON FORTH EXTENSIONS for the P2 - 171212-0000 " ;

( ************************* DICTIONARY CONTROL ***************************** )

pub PRIVATE 	( -- )		8 flags SET ;
pub PUBLIC	( -- )		8 flags CLR ;

pub @NAMES 	names @	;

pub @HATR ( -- atrptr )		@NAMES C@++ + ;

{
pub IMMEDIATE ( --   )		BL @HATR SET ;
IMMEDIATE
}
pre UNSMUDGE ( --   )	 	$40 @HATR CLR ;
\ IMMEDIATE

pre ALIAS ( <old> <new> -- )
	[C] NFA'
	[C] GRAB
	C@++ +
	[C] CREATE$
	@HATR 3 CMOVE
;

pre ;;
	1 @here 4+ @ 2- W+!
	' ; 6 + CALL
	;
pub <CR>			$0D EMIT ;;

pub LIMIT ( n min max -- n )	ROT MIN MAX ;


\ set the ECHO flag on/off for controlling output
pub ECHO ( on/off --  )		1 flags ROT
pub BITS!			IF SET ELSE CLR THEN ;

pub OK				IF 0 ELSE ' <CR> THEN accept W! ;
\ Strip out annoying linefeeds from the output during a source code load but pass $0B as a LF
\ pub LEMIT			DUP $0A <> IF 8 REG W@ ?DUP IF CALL ELSE CONEMIT THEN ELSE DROP 1 lines W+! THEN ;
\ start of load symbol - suppress console interaction
\ pub [~				OFF ECHO OFF OK  uemit W@ 8 REG W! ' LEMIT uemit W! ;
\ end of load symbol - reenable interactive console
\ pub ]~				ON ECHO ON OK 8 REG W@ uemit W! ;
\ [~			\ Now run in quiet mode with no echo and LF suppression

\ pub !!SP			!SP $DEADBEEF ;	--- Init the datastack but leave a $DEADBEEF marker on it for stack debug
\ !!SP

#80,000,000		== CLKFREQ			--- Create a constant for CLKFREQ rather than accessing location 0
CLKFREQ 1,000,000 U/	== CLKMHZ

$F000			== BUFFERS

{
SETCLK	##$3000_0000	'write-protect RAM at $FC000..$FFFFF
SETCLK	##$2000_0000	'write-enable RAM at $FC000..$FFFFF (defau
}

$0F.C000	== ROM
ROM $3FE0 + 	== VECTORS

pub WP 			$3000.0000 CLKSET ;
pub WE			$2000.0000 CLKSET ;
pub 80MHZ		$FF CLKSET ;
pub 40MHZ		$7F CLKSET ;
pub 20MHZ		$3F CLKSET ;
pub 10MHZ		$1F CLKSET ;
pub 5MHZ		$0F CLKSET ;
pub RCSLOW		1 CLKSET ;


pub us				CLKMHZ W* 485 - WAIT ;

\ pub PCB$			" BeMicroCV-A9" ;
\ $BEA9				== PCB
{
pub PCB$			" DE2-115" ;
$DE2115				== PCB
}

ALIAS @ U@
ALIAS ! U!

ALIAS SHR >>
ALIAS SHL <<

ALIAS RESET REBOOT

--- Force cog to run Forth and set task
pub RUN ( cfa task -- )		4 @ 9BITS OVER COGINIT TASK ! ;

pub BIT! ( on/off bit -- )	SWAP IF HIGH ELSE LOW THEN ;

--- set EMIT to discard characters like \dev0
pub NULLOUT ( -- )		' DROP uemit W!	;

pub LASTKEY ( -- ch )		rxptr @ DUP 2- W@ 1- 16 BITS SWAP + C@ ;
\ pub RAM				dmm 6 ERASE ;


ALIAS ." PRINT"
ALIAS . PRINTS
ALIAS .DEC PRINTDEC


ALIAS { {HELP	--- }
ALIAS --- //

pub CFA>NFA ( pfa -- nfa \ find the nfa else false )
	@NAMES 1+
	BEGIN
	  DUP NFA>CFA >PFA 3RD = IF NIP 1- EXIT THEN
	  NFA>CFA 3 +
	  DUP C@ 0=
 	UNTIL
	2DROP 0
	;



--- change the value of a constant --- 47 ' <CONSTANT> CHANGE
pub K! ( val 'con -- )		2+ ! ;




VARIABLE _datorg
VARIABLE _datptr

pub DATPTR ( -- addr )			_datptr @ ;

pub DATORG ( addr -- )			DUP _datorg ! _datptr !  ;

$E000 DATORG	--- create DAT area

--- assign storage without assigning a symbol
pub res ( bytes -- )			_datptr +! ;

--- assign storage to the symbol
pre BYTES ( bytes <name> -- )		[C] GRAB DATPTR SWAP res [C] DATCON ;
pre words				[C] GRAB 4* [C] BYTES ;
pre LONGS				[C] GRAB 4* [C] BYTES ;

pre BYTE				1 [C] BYTES ;
pre WORD				2 [C] BYTES ;
pre LONG				4 [C] BYTES ;


--- code space variables which are backed up to EEPROM along with code during BACKUP - 170701 now includes an initialization value
pre cbyte ( val -- )		[C] GRAB 				HERE >R [C] |	R> [C] == ;
pre cword ( val -- )		[C] GRAB HERE 1 AND ALLOT		HERE >R [C] ||  R> [C] == ;
pre clong ( val -- )		[C] GRAB 4 HERE 3 AND - 3 AND ALLOT	HERE >R [C] ,   R> [C] == ;

\ pre cbytes ( cnt -- )		[C] GRAB HERE >R FOR 0 [C] | NEXT R> [C] == ;


	--- P2 COG REGISTER NAMES ---

$1F6	== ADRA
$1F7	== ADRB
$1F8	== PTRA
$1F9	== PTRB
$1FA	== DIRA
$1FB	== DIRB
$1FC	== OUTA
$1FD	== OUTB
$1FE	== INA
$1FF	== INB


pub DPL ( -- n )	\ Return with number of decimal places
 	digits 1+ C@ DUP IF digits C@ SWAP - THEN
 	;
\ Flag next number print routine to use leading spaces instead of leading zeros
pub LSP 	4 flags SET ;


( MATHS FUNCTIONS )
--- basic maths functions - always load
pub U>    SWAP U< ;

pub /  ( n1 n2 -- n3 ) 					\ 18us signed divide (org 47us) vs 10us U/
  	OVER ABS OVER ABS U/ 				\ perform unsigned division
 	ROT ROT XOR -NEGATE				\ now get signs set result accordingly
 	;


pub DOT		"." EMIT ;


{
--- Demonstrate blinking leds (on DE2-115) at different rates in all the unused cogs
VARIABLE DLY  #50 DLY !
pub LEDTASK   COGID BEGIN DUP #32 + HIGH DUP DLY @ * ms DUP #32 + LOW DUP DLY @ * ms AGAIN ;
\ 16 1 DO ' LEDTASK I RUN LOOP
}


pub >W						$FFFF AND ;
pub L>W ( long - loword hiword )		DUP >W SWAP 8>> 8>> ;
pub W>B ( word - lobyte hibyte )		DUP >B SWAP 8>> >B ;

pub W>L ( loword hiword -- long )		8<<
pub B>W	( lobyte hibyte -- word )		8<< OR ;
pub B>L ( lobyte byte2 byte3 byte4 -- long  )	B>W >L B>W L> W>L ;

\ Increment and decrement variables at address
pub ++ ( longAddr --   increment long )		1 SWAP +! ;
pub -- ( longAddr --   decrement long )		-1 SWAP +! ;
pub W++ ( wordAddr --  increment word )		1 SWAP W+! ;
pub W-- ( wordAddr --  decrement word )		-1 SWAP W+! ;
pub C++ ( byteAddr --  increment byte )		1 SWAP C+! ;
pub C-- ( byteAddr --  decrement byte )		-1 SWAP C+! ;
IFNDEF ~
\ Clear and set variable at address
pub ~   ( longAddr --  clear long )		0 SWAP ! ;
pub ~~  ( longAddr --  set long   )		-1 SWAP ! ;
pub W~  ( wordAddr --  clear word )		0 SWAP W! ;
pub W~~ ( wordAddr --  set word   )		-1 SWAP W! ;
pub C~  ( byteAddr --  clear byte )		0 SWAP C! ;
pub C~~ ( byteAddr --  set byte   )		-1 SWAP C! ;
}

pub SQRTD ( n -- res.6 )
	SQRT L>W #1000000 * SWAP #1000000 UM*
	16 << SWAP 8>> 8>> OR +
	;








( MORE OPERATORS )
--- given align = 2^n set the n-1 lowest bits to 0
--- align the address to a ‘align’ bytes border
---  n = 0 is byte align, n = 1 is word align, n = 2 is long align )
pub ALIGN ( address align -- val00  )					1- SWAP OVER + SWAP ANDN ;



pub =>	( n1 n2 -- flg  \ true if n1 is equal to or greater than n2 ) 	1- > ;
pub <=	( n1 n2 -- flg  \ true if n1 is smaller than or equal to n2 )	SWAP => ;


pub @.	( longAddr --  \ Fetch long and print number )			@ U. ;



	--- STRINGS ---


--- 40 STR" HELLO WORD"
--- " HELLO WORLD" 40 STR

pre STRING ( str max -- )
	[C] GRAB  ( str max )
	OVER LEN$ MAX 1+ ( str max )
	SWAP DATPTR 3RD CMOVE
	[C] BYTES
	;



\ Create a NULL$ constant

BYTE NULL$    NULL$ C~

{ Copy one string to another (store)
Usage:
" NOW IS THE TIME" $20 STRING A$
NULL$ $20 STRING B$
A$ B$ COPY$
}
pub COPY$ ( str1 str2 -- )
	OVER LEN$ 1+ CMOVE
 	;

ALIAS COPY$ $!			\ Just an alias plus I like to think of this as "string store" analogous to ! operation

{ Append a string
Usage: " MY NAME IS " $20 STRING NAME
" PETER" NAME APPEND$
NAME PRINT$ MY NAME IS PETER ok
}
pub APPEND$ ( str1 str2 -- \ append str1 at the end of str2 )
	DUP LEN$ + COPY$
	;
{ Append a character to a string and null terminate
Usage:
"*" NAME +CHAR  ok
NAME PRINT$ MY NAME IS PETER* ok
}
pub +CHAR ( ch str2 -- \ add a character to a string )
	DUP LEN$ + OVER 1+ C~ C!
	;
pub MID$ ( str offset len -- str \ extract the substring of str starting at offset len chars long )
	>L + L>

pub LEFT$ ( str len -- str \ Destructive LEFT$ - uses same string )
	OVER + C~
	;
pub RIGHT$ ( str len -- str \ give a copy of the rightmost len chars of str )
	OVER LEN$ SWAP - +
	;
pub ERASE$ ( str -- \ Fully erase the string - reads max len from header )
	DUP 3 - C@ ERASE
	;
pub LOCATE$ ( ch str -- str \Locate the first ch in the string and return else null )
	0 SWAP DUP LEN$ ADO OVER IC@ = IF DROP I LEAVE THEN LOOP
	NIP
	;

pub COMPARE$ ( str1 str2 -- flg \ Compare two strings for equality )
	OVER LEN$ OVER LEN$ =
	IF
	DUP LEN$
	ADO C@++ IC@ <> IF DROP 0 LEAVE THEN LOOP
	0<>
	ELSE 2DROP FALSE
	THEN
	;

ALIAS COMPARE$ $=

pri >UPPER  ( str1 --  ) --- Convert lower-case letters to upper-case
	DUP LEN$ ADO IC@ "a" "z" WITHIN IF IC@ BL XOR I C! THEN LOOP
	;

#40 BYTES _str
pub >CSTR 			_str 1+ $! _str 1+ LEN$ _str C! _str ;

pub FIND ( str -- cfa )		>CSTR @NAMES FINDSTR DUP IF NFA>CFA >PFA THEN ;
pub CALL$				FIND ?DUP IF CALL THEN ;



{
--- redefine ms and us to suit clkfreq
pub ms
 	?DUP 0EXIT CLKFREQ #1000 / UM* DROP DELTA
 	;
}


BYTE pstkwr
8 LONGS pstk
{HELP PUSH ( n -- )
PUSH value onto global stack
}

pub PUSH	pstkwr C@ $1F AND pstk + ! 4 pstkwr C+! ;
pub POP		-4 pstkwr C+! pstkwr C@ $1F AND pstk + @ ;
}

LONG radix			\ 4 level deep radix stack
pub RADIX ( base -- \ Set number base )
 	?DUP IF base C! THEN
 	;
pub >RADIX ( base -- \ backup and set number base )
 	radix @ 8<< base C@ + radix ! RADIX
 	;
pub RADIX> ( -- \ restore previous radix )
 	radix @ DUP RADIX 8>> radix !
 	;

pub .BIN ( long -- )	PRINT"  %" REV BL 0 DO I 7 AND 0= IF '_' EMIT THEN DUP I MASK AND IF ." 1" ELSE ." 0" THEN  LOOP DROP ;



pub .LAP	LAP@  LAP LAP LAP@ -  DUP DECIMAL . ."  cycles = "
pri ~l
	DUP CLKFREQ < IF 100 * 3 >> ELSE CLKFREQ U/MOD PRINT DOT #1000 CLKFREQ */ PRINT PRINT" sec" EXIT THEN
	DUP #999999 > IF #1,000,000 U/MOD PRINT DOT  #1000 U/ PRINT PRINT" ms " EXIT THEN
	DUP #999 > IF #1,000 U/MOD PRINT DOT PRINT PRINT" us" EXIT THEN
 	 PRINT PRINT" ns "
	;
pub .ms		LAP@ LAP LAP LAP@ - ~l ;



pub D.				<D> . ;

DECIMAL
{
pub fibo ( n -- f )		1- 0 1 ROT FOR +FIB NEXT NIP ;
pub FIBOS			#47 6 DO CR ." fibo(" I . ." ) = " I  LAP fibo  LAP .LAP ."  result =" . 10 +LOOP ;
}
\ pub SPACES ( cnt -- ) 		$20 SWAP
pub EMITS ( ch cnt -- ) 	?DUP IF FOR DUP EMIT NEXT THEN DROP ;
pub CONIO			uemit ~ ;

pub WKEY			BEGIN KEY ?DUP UNTIL ;


pub TAB				9 EMIT ;

\ pub CTYPE ( cstr -- )		DUP 1+ SWAP C@ BOUNDS DO IC@ EMIT LOOP ;

pub WTAB			DUP C@ 9 + #22 SWAP - 1 MAX SPACES ;

pub .ATRS ( atr -- )
 	DUP 3 >> 5 0 DO DUP I MASK AND IF " pxish" I+ C@ EMIT ELSE DOT THEN LOOP
	DROP 7 AND .
	;


VARIABLE ww	--- byte 0 = delay ; byte 1 = count ; byte 2 = words/line


pub WORDS
	0 names @
	BEGIN
	  ww C@ ms
	  OVER 0= IF CR NIP ww 2+ C@ DUP 0= IF DROP 4 THEN  SWAP THEN   ( words per line )
	  DUP NFA>CFA 1- C@ .ATRS
	  SPACE DUP .WORD
	  SPACE DUP C@ OVER + 2+ W@ .WORD
	  SPACE SPACE DUP 1+ PRINT$ WTAB
	  SPACE DUP C@ + 4+			--- next name
\	  SPACE 2+
	  SWAP 1- SWAP
	  DUP C@ 0=
	  KEY ?DUP IF $1B <> IF WKEY DROP ELSE 1 OR THEN THEN
	  ww 1+ C@ IF -1 ww 1+ C+! ww 1+ C@ 0= OR THEN
	UNTIL
	2DROP ww ~
	;

pub PWORDS	#10 ww C! WORDS ;
pub QW		#40 ww 1+ C! WORDS ;

pub $		'$' EMIT ;
pub .B		$ .BYTE ;
pub .W		$ .WORD ;
pub .L		$ .LONG ;

pub .ADDR		DUP 16 >> SPACE .B DOT .WORD ;

        --- dump LUT memory
pub LUTDUMP
	ADO I 7 AND 0= IF CR I .ADDR SPACE THEN I LUT@ .LONG SPACE LOOP
	;

long dmp
pub COG			' COGDUMP dmp W! ;
pub LUT			' LUTDUMP dmp W! ;
'd' NFA' DUMP 1+ C!	--- rename old DUMP so we can refer to it (smudginess)
pub DUMP		dmp W@ ?DUP IF CALL ELSE dUMP THEN 0 dmp W! ;


ALIAS 2+ COGREG
pub COGREG@	COGREG COG@ ;
pub COGREG!	COGREG COG! ;

0 COGREG	== sck
1 COGREG	== mosi
2 COGREG	== miso
3 COGREG	== scs


{
' Offsets in LUT for stacks
datstk		= $000
brastk		= $020
lpstk		= $030
retstk		= $040
' The LUT is essentially free from $80 onwards

COGREG 15
datptr		long	0  		' data stack pointer to LUT
braptr		long	0		' branch stack pointer to LUT
lpptr		long	0
retptr		long	0		' return stack pointer to LUT

depth		long	0

}

pri DMPSTK ( base ptr -- )	3 SPACES SWAP BEGIN 2DUP <> WHILE DUP LUT@ SPACE .LONG 1+ REPEAT 2DROP ;

pub .DSTK	CR PRINT"  DATA   x" 19 COGREG@ 1- . 15 COGREG@ 1+ 2+ 4 SWAP DMPSTK ;
pub .S
	.DSTK
	CR PRINT"  BRANCH x" $20 16 COGREG@ 2DUP SWAP - . DMPSTK
	CR PRINT"  LOOP   x" $30 17 COGREG@ 2DUP SWAP - . DMPSTK
	CR PRINT"  RETURN x" $40 18 COGREG@ 2DUP SWAP - . DMPSTK
;

--- Quick reg list
pub QR		5 0 DO CR I .BYTE ." : " I COGREG@ .LONG LOOP ;


pub MAP ( blksize -- )
 	HEX $10 MAX $1000 MIN
	0 SWAP $10.0000 0 DO
	OVER $3F AND 0= IF CR I .ADDR SPACE THEN
	SWAP 1+ SWAP  0 I 3RD ADO I @ OR 4 +LOOP
	IF  I OVER U/ $0F AND . ELSE ." ." THEN
	 DUP +LOOP 2DROP
	 ;

pub KB	#10 << ;
pub MB	#20 << ;

pub QMAP	$100 MAP ;


pub .P ( n digits -- ) base C@ >L DECIMAL <# FOR # NEXT #> PRINT$ L> base C! ;

pub .INS ( instr -- )
	BINARY
	DUP #28 >> 4 "%" EMIT .P SPACE
	DUP #19 >> 9BITS 9 "%" EMIT .P SPACE
	HEX
\ 	DUP #18 >> 1 AND IF ." I" ELSE ." R" THEN
	SPACE
 	DUP #9 >> 9BITS .WORD ." ,"
	DUP #18 >> 1 AND IF ." #" ELSE SPACE THEN 9BITS .WORD
 	;
pub COGLIST
	ADO CR I .WORD ." : " I COG@ DUP .LONG 3 SPACES .INS LOOP
	;




( ********************************* SERIAL FLASH ******************************* )
{
BeMicroCV-A9            SW1
41	CLK     CLK  	60
40	CMD 	DI      58
36	D0      DO      59
37	D1
38	D2
39	D3	CS  	61
}

( WINBOND 25Q80 )
{
#P61	== sfcs
#P60	== sfck
#P59	== sfdi
#P58	== sfdo
}


{
SFWD	mov	X,#4
	jmp	#_SFINS
SFWE	mov	X,#6
_SFINS	drvh	#sfcs
_SFWR	call	#SFIO
	shl	X,#24
	rep	@.L1,#8
	rol	X,#1 wc
	drvc	#sfdi		' send data bit out
	drvh	#sfck  		' clock it
	drvl	#sfck
.L1	ret

}
{
pub SFEND			#61 HIGH ;

IFNDEF SFINS
pub SFINS			SFEND SFWR ;
pub SFWE			6 SFINS ;
pub SFWD			4 SFINS ;
pub SFADR ( sfaddr -- )		DUP 8>> 8>> SFWR DUP 8>> SFWR SFWR ;

pub SFRDBLK ( sfaddr dst cnt -- )
	3 SFINS ROT SFADR
	ADO SFRD I C! LOOP
	SFEND
	;
}


{
( Read multiple bytes and assemble them into a long )
pub SFRDS ( cnt -- long )	0 SWAP FOR 8<< SFRD + NEXT ;

( Read serial Flash serial number )
pub SFSID			$4B SFINS 8 SFRDS 4 SFRDS SFEND ;;

( Read serial Flash Jedec ID )
pub SFJID			$9F SFINS SFRD SFEND ;;


pub SFERSEC ( addr -- )		SFWE $20 SFINS SFADR SFEND ;;
pub SFER32K ( addr -- )		SFWE $52 SFINS SFADR SFEND ;;
pub SFER64K ( addr -- )		SFWE $D8 SFINS SFADR SFEND ;;
pub SFERCHIP			SFWE $C7 SFINS SFEND ;;

pub SFWRPAGE ( src dst -- )	SFWE $02 SFINS SFADR #256 ADO IC@ SFWR LOOP SFEND ;;
pub SFWRBLK ( src dst cnt -- )  ROT SWAP ADO I OVER SFWRPAGE 3 ms SPINNER #256 + #256 +LOOP DROP ;

--- backup the first 64K of memory into flash
pub BACKUP			0 SFER64K #1,000 ms 0 0 $1.0000 SFWRBLK ;;

pub SFC@			3 SFINS SFADR SFRD SFEND ;;
pub SFW@			3 SFINS SFADR SFRD SFRD 8<< OR SFEND ;;

pub SF@ ( addr -- long )	3 SFINS SFADR SFRD SFRD 8<< OR SFRD 8<< 8<< OR SFRD 8<< 8<< 8<< OR SFEND ;;

--- Select Serial Flash as memory for DUMP words
pub SF				DUMP: SFC@ SFW@ SF@ ;


}

{
(	WS2812		)
( Specify data pin using PIN function )

$1.0000 == ledbuf
pub LED! ( color led -- )	3 W* ledbuf + 3 ADO DUP >B I C! 8>> LOOP DROP
pub SHOW 			ledbuf 40 WS2812 ;
}






(	SMART PINS	)
{
D/# = %AAAA_BBBB_FFF_PPPPPPPPPPPPP_TT_MMMMM_0	mode fields
      %1098_7654_321_0987654321098_76_54321_0	absolute bit position
       3210 3210 210 2109876543210 10 43210 -	local bit fields
       **** **** [---][--][--][--] [---][---] 	hex grouping
dac mode             101			= $14.0000

%MMMMM:    00000   = smart pin off (default)
00001   = byte repository              (P[12:10] != %101)
00010   = word repository              (P[12:10] != %101)
00011   = long repository              (P[12:10] != %101)
00001   = DAC noise                    (P[12:10]  = %101)
00010   = DAC 16-bit dither, noise     (P[12:10]  = %101)
00011   = DAC 16-bit dither, PWM       (P[12:10]  = %101)
00100*  = pulse/cycle output
00101*  = transition output
00110*  = NCO frequency
00111*  = NCO duty
01000*  = PWM triangle
01001*  = PWM sawtooth
01010*  = PWM switch-mode power supply, V and I feedback
01011   = periodic/continuous, A-B quadrature encoder
01100   = periodic/continuous, inc on A-high
01101   = periodic/continuous, inc on A-rise
01110   = periodic/continuous, inc on A-high, dec on B-high
01111   = periodic/continuous, inc on A-rise, dec on B-rise
10000   = time A states
10001   = time A-high states
10010   = time X A-highs
10011   = for X periods, count time
10100   = for X periods, count states
10101   = for periods in X+ clocks, count time
10110   = for periods in X+ clocks, count states
10111   = for periods in X+ clocks, count periods
11000*  = USB host, low-speed          (even/odd pin pair = DM/DP)
11001*  = USB host, high-speed         (even/odd pin pair = DM/DP)
11010*  = USB device, low-speed        (even/odd pin pair = DM/DP)
11011*  = USB device, high-speed       (even/odd pin pair = DM/DP)
11100*  = sync serial transmit         (A-data, B-clock)
11101   = sync serial receive          (A-data, B-clock)
11110*  = async serial transmit        (baudrate)
11111   = async serial receive         (baudrate)

* OUT signal overridden
}

IFNDEF AKPIN
--- Acknowledge smart pin S/# (2 clocks)
pub AKPIN ( pin -- )	1 SWAP SETPIN ;
}

lines 2+ 0 REG -	== pinreg		--- configure a spare task register (after "lines" REG)

IFNDEF PIN
--- NOTES - PIN & @PIN could store in cog using fast instructions (updated)
pub PIN ( pin -- )	pinreg REG C! ;
pub @PIN ( -- pin )	pinreg REG C@ ;
}



{
%00110 = NCO frequency
This mode overrides OUT to control the pin output state.
X[15:0] establishes a base period in clock cycles which forms the empirical high and low times.
Y[31:0] will be added into Z[31:0] at each base period.
The pin output will reflect Z[31].
IN will be raised whenever Z overflows.
During reset (DIR=0), IN is low, the output is low, and Z is set to zero.
}
pub NCO ( cntval div -- )	@PIN LOW $4C SETPIN WXPIN WYPIN ;

-1 2/ CLKFREQ 10000 / 2/ /	== HZCON
pri NCOCNT ( freq -- ncocnt )	HZCON #10000 */ ;

--- Set smartpin to NCO mode and frequency
pub HZ ( hz -- )		NCOCNT 1 NCO ;
pub KHZ ( khz -- )	 	#1000 * HZ ;
pub MHZ ( Mhz -- )	 	#1000 * kHZ ;

--- Stop the smartpin mode
pub MUTE ( -- )             	@PIN FLOAT 0 SETPIN ;

--- quick easy way to typically blink an LED - to blink faster etc just use HZ
pub BLINK ( pin -- )		PIN 2 HZ ;


--- TRIANGLE PWM MODE
pub PWM ( duty frame div -- )	@PIN LOW $50 SETPIN SWAP 16 << + WXPIN WYPIN ;

{
$7C %11110 = asynchronous serial transmit
This mode overrides OUT to control the pin output state.
Words from 1 to 32 bits are serially transmitted on the pin at a programmable baud rate.
WXPIN is used to configure the baud rate and word length.
X[31:16] establishes the baud rate. Both NCO and counter modes are available:
X[31] = 0 selects counter mode, where X[30:16] is a 15-bit value which sets the number of clocks in a bit period.
X[31] = 1 selects NCO mode, where X[30:16] is a 15-bit value which gets added into a 16-bit accumulator on each internal clock cycle. The rollover period of the accumulator is the bit period. This value can be computed as follows: desired_baud_rate / system_clock_frequency * $1_0000.
X[4:0] sets the number of bits, minus 1. For example, a value of 7 will set the word size to 8 bits.
WYPIN is used to load the output words. The words first go into a single-stage buffer before being advanced to a shifter for output. This buffering mechanism makes it possible to keep the shifter constantly busy, so that gapless transmissions can be achieved. Any time a word is advanced from the buffer to the shifter, IN is raised, indicating that a new word can be loaded.
Here is the internal state sequence:
Wait for an output word to be buffered via WYPIN, then set the buffer-full and busy flags.
Move the word into the shifter, clear the buffer-full flag, and raise IN.
Output a high for one bit period (guarantees a whole STOP bit).
Output a low for one bit period (the START bit).
Output the LSB of the shifter for one bit period, shift right, and repeat until all data bits are sent.
Output a high (begins the STOP bit).
If the buffer-full flag is set due to an intervening WYPIN, loop to (2). Otherwise, clear the busy flag and loop to (1).

RDPIN returns 8 bits and can always be used to read the busy flag into D[7]/C.
During reset (DIR=0) the output is held high.
}
--- Make a local copy of the asynch data len to be used when TXD or RXD is invoked
pub DATABITS ( datalen -- )	1- pinreg 1+ REG C! ;
pri @DL ( -- datalen )		pinreg 1+ REG C@ ;

{ debug output for SETPIN and WXPIN
			   %AAAABBBBFFFPPPPPPPPPPPPPTTMMMMM0  |---BAUD-------|           8BITS
TF2# 26 PIN 1,000,000 RXD  %00000000000000000000000000111110 %00000000010100000000000000000111 ok
                                                    00111110
						      11111 = RXD
						    00  = OUTPUT ENABLED !!!!
pri BAUD! ( baud mode -- )	DUP .BIN SETPIN CLKFREQ SWAP U/ 16 <<  @DL 0= IF 8 DATABITS THEN @DL + DUP .BIN WXPIN  ;
pub TXD ( -- )		$7C BAUD! @PIN LOW ;
pub RXD ( -- )		$3E BAUD! ;
}
--- changed syntax once again to skip the redundant although readable BAUD word - now 115,200 RXD is sufficient to set mode
pri BAUD! ( baud mode -- )	SETPIN CLKFREQ SWAP U/ 16 <<  @DL 0= IF 8 DATABITS THEN @DL + WXPIN  ;

pub TXD ( -- )		$7C BAUD! H ;
pub RXD ( -- )		$3E BAUD! ;
{
WS2812 using 21-bit asynch for each byte @2,500,000 BAUD
S0123456789012345678901P
1D01D01D01D01D01D01D01D0	<--- encode 8-bit as 21 bits

63 data bits per RGB LED


 %11011010 TX
}
--- NOTE - slower baud rates are best buffered and handled under interrupts etc.
pub TX ( data -- ) 		BEGIN RDPIN $80 AND 0= UNTIL WYPIN ;

ifndef TXTE
pub TXTE ( te data -- ) 	OVER HIGH WYPIN BEGIN RDPIN $80 AND 0= UNTIL LOW ;
}

pub TXSTR ( str -- )		DUP LEN$ TXDAT ;

{ To setup serial ports
7 PIN 115,200 TXD BAUD
6 PIN 115,200 RXD BAUD

To use 7 data bits
7 DATABITS
then use xXD BAUD to set the pin
}

{
$7E %11111 = asynchronous serial receive
Words from 1 to 32 bits are serially received on the A input at a programmable baud rate.
WXPIN is used to configure the baud rate and word length.
X[31:16] establishes the baud rate. Both NCO and counter modes are available:
X[31] = 0 selects counter mode, where X[30:16] is a 15-bit value which sets the number of clocks in a bit period.
X[31] = 1 selects NCO mode, where X[30:16] is a 15-bit value which gets added into a 16-bit accumulator on each internal clock cycle. The rollover period of the accumulator is the bit period. This value can be computed as follows: desired_baud_rate / system_clock_frequency * $1_0000.
X[4:0] sets the number of bits, minus 1. For example, a value of 7 will set the word size to 8 bits.
Here is the internal state sequence:
Wait for the A input to go high (idle state).
Wait for the A input to go low (START bit edge).
Delay for half a bit period.
If the A input is no longer low, loop to (2).
Delay for one bit period.
Right-shift the A input into the shifter and delay for one bit period, repeat until all data bits are received.
Capture the shifter into the Z register and raise IN.
Loop to (1).

RDPIN is used to read the received words. The shift offset of the RDPIN data is dependent on the word size:

For 1..8 bits, RDPIN receives 8 bits and data will be left-justified at bit 7, with bits 31..8 cleared.
For 9..16 bits, RDPIN receives 16 bits and data will be left-justified at bit 15, with bits 31..16 cleared.
For 17..32 bits, RDPIN receives 32 bits and data will be left-justified at bit 31.

The RDPIN result may need to be right-shifted to LSB-justify it. For example, if you received a 9-bit word into D, do a SHR D,#16-9, since its MSB is at bit 15. If you received an 8-bit word, no shifting is necessary, as its MSB is already at bit 7.
}
pub RX ( -- data )	BEGIN @PIN PIN@ UNTIL RDPIN AKPIN ;

--- version using internal PIN@ for all PIN instructions
\ pub RX ( -- data )	BEGIN @PIN PIN@ UNTIL RDPIN AKPIN ;



{HELP SERIAL ( pin -- )
Redirect character output to a preset smartpin serial transmit
Usage 0 SERIAL PRINT" HELLO WORLD"
Note - still need to add RX and also busy checks etc
}

pub SERIAL ( pin -- )		PIN ' TX uemit W! ;







{
$78 %11100 = synchronous serial transmit

This mode overrides OUT to control the pin output state.
Words of 1 to 32 bits are shifted out on the pin, LSB first,
with each new bit being output two internal clock cycles after registering a positive edge on the B input.
For negative-edge clocking, the B input may be inverted by setting B[3] in WRPINs D value.

WXPIN is used to configure the update mode and  word length.

X[5] selects the update mode:

X[5] = 0 sets continuous mode, where a first word is written via WYPIN during reset (DIR=0) to prime the shifter. Then, after reset (DIR=1), the second word is buffered via WYPIN and continuous clocking is started. Upon shifting each word, the buffered data written via WYPIN is advanced into the shifter and IN is raised, indicating that a new output word can be buffered via WYPIN. This mode allows steady data transmission with a continuous clock, as long as the WYPINs after each IN-rise occur before the current word transmission is complete.

X[5] = 1 sets start-stop mode, where the current output word can always be updated via WYPIN before the first clock, flowing right through the buffer into the shifter. Any WYPIN issued after the first clock will be buffered and loaded into the shifter after the last clock of the current output word, at which time it could be changed again via WYPIN. This mode is useful for setting up the output word before a stream of clocks are issued to shift it out.

X[4:0] sets the number of bits, minus 1. For example, a value of 7 will set the word size to 8 bits.

WYPIN is used to load the output words. The words first go into a single-stage buffer before being advanced to the shifter for output. Each time the buffer is advanced into the shifter, IN is raised, indicating that a new output word can be written via WYPIN. During reset, the buffer flows straight into the shifter.

If you intend to send MSB-first data, you must first shift and then reverse it. For example, if you had a byte in D that you wanted to send MSB-first, you would do a SHL D,#32-8 and then a REV D.

During reset (DIR=0) the output is held low. Upon release of reset, the output will reflect the LSB of the output word written by any WYPIN during reset.


WRPIN D/# = %AAAA_BBBB_FFF_PPPPPPPPPPPPP_TT_MMMMM_0
a = data b = clock


WRPIN   {#}D,{#}S	Write D to mode register of smart pin S[5:0], acknowledge smart pin.
AKPIN   {#}S	Acknowledge smart pin S[5:0].
WXPIN   {#}D,{#}S	Write D to parameter "X" of smart pin S[5:0], acknowledge smart pin.
WYPIN   {#}D,{#}S	Write D to parameter "Y" of smart pin S[5:0], acknowledge smart pin.

pri BAUD! ( baud mode -- )	SETPIN CLKFREQ SWAP U/ 16 <<  @DL 0= IF 8 DATABITS THEN @DL + WXPIN  ;

}
---				SYN       BITS MODE
pub SYNTX ( bits -- )  		$78 SETPIN 1- $20 OR WXPIN ;
--- Use TX to send via this pin










( PING-PONG CHAT USING SMARTPINS )
{
pub CHAT ( device pin -- )
	DUP PIN 1+ TEPIN $80 OR 1000000 RXD TXTE
	  BEGIN rxptr @ READBUF DUP $11B <> WHILE TXTE BL FOR R ?NEXT DROP RDPIN AKPIN EMIT REPEAT
	$80 TXTE
	;
}

( RESET BUS DEVICES )
pub PPRST 	@PIN 1+ DUP HIGH MUTE L 100 ms H LOW ;

BYTE _bus
pub BUS ( n -- ) 3 AND 2* 24 + _bus C! ;
0 BUS
1000000 == ppbaud

pub TXRX ( ch -- res )		TXTE BL FOR R ?NEXT DROP RDPIN AKPIN  ;
pub SEL ( adr -- )		$80 OR TXRX DROP ;

pub TXSTR ( str -- )		BEGIN C@++ ?DUP WHILE TXRX DROP REPEAT DROP ;



pub CHAT ( device -- )
	_bus C@ DUP PIN 1+ TEPIN $80 OR ppbaud RXD TXTE
	  BEGIN KEY DUP ^Q <> WHILE TXRX ?DUP IF EMIT THEN REPEAT
	DROP $80 TXTE
	;

$EF	== ALL



( --- --- --- ANSI TERMINAL SUPPORT --- --- --- )

0	== black
1	== red
2	== green
3	== yellow
4	== blue
5	== magenta
6	== cyan
7	== white

pub ESC ( ch -- )		$1B EMIT EMIT ;
pub ESCB ( ch -- )		"[" ESC EMIT ;

pub COL ( col fg/bg -- )	ESCB "0" + EMIT "m" EMIT ;
pub PAPER ( col -- )		"4" COL ;
pub PEN ( col -- )		"3" COL ;

pub .PAR			SWAP 2 .P EMIT ;

pub CUR ( cmd n -- )		"[" ESC SWAP .PAR ;

pub XY ( x y -- )		";" SWAP CUR "H" .PAR ;

pub HOME			"H" ESCB ;



pub ERSCN			"2" ESCB "J" EMIT ;

pub CLS				$0C EMIT HOME ERSCN ;

pub ERLINE			"2" ESCB "K" EMIT ;

pub CURSOR ( on/off -- )
	"?" ESCB ." 25"
	IF "h" ELSE "l" THEN EMIT
	;

pub ATR ( ch -- )		ESCB "m" EMIT ;

pub PLAIN			"0" ATR ;

pub REVERSE			$37 ATR ;
pub BOLD			$31 ATR ;




--- --- --- --- --- --- NUMBER FORMATTING --- --- --- --- ---


pub (SEP)
	 I IF 1 REG C@ $40 AND 0EXIT
 	 base C@ #10 =
	   IF I 3 MOD 0= IF "," HOLD THEN				\ Process decimal numbers with a decimal point
	   ELSE I 4 MOD 0= IF "_" HOLD THEN				\ or else use underscore for a separator
	   THEN
	 THEN
	;
{ Usage: - testing
	WORD sep
pri InitSep ( digits base -- digits base )
	DUP #10 = IF $2C03 sep W! THEN
	DUP ":" = IF DROP #10 $3A02 sep W! THEN
	DUP "/" = IF DROP #10 $2F02 sep W! THEN
}

pub (PRINTNUM) ( n val -- )
	<# 5 BITS ?DUP 						--- If there is a count (b4..b0) specified then lock to that
	  IF DUP #31 = IF 1+ THEN 0 DO (SEP) # LOOP		--- fixed width also 31(max) indicates 32 binary digits
	  ELSE BL 0 DO (SEP) # DUP 0= IF LEAVE THEN LOOP	--- variable width, don't print lz
	  THEN
	0 REG C@ ?DUP IF HOLD THEN
	#> PRINT$
	;


{ HELP PRINTNUM ( number format -- )
Format the number as to it's base, the number of digits, whether it's signed, and should it have separators
This is a very versatile print number routine and can be incorporated into other print words
A single word is passed with options:
b07..00 = base
b12..08 = digits
b13	 = use spaces in place of leading zeros
b14	= force separators (decimals have a , every 3 places while others have a _ every 4 places)
b15	= force sign (always + or - depending upon the number)
Usage:
 	$C00A will force separaStors, sign, no leading zeros (0 digits), and a base of 10
i.e.	0 @ $C00A PRINTNUM +80,000,000 ok
	$4810 will force separators, no sign, and 8 digits with a base of 16
i.e.	0 @ $4810 PRINTNUM 04C4_B400 ok
}
pub PRINTNUM  ( number sign+sep+6BitForDigits+8BitForBase -- \ format number according to format spec )
	W>B SWAP
\	InitSep
	>RADIX
	0 REG C~							--- clear prefix for sign
	DUP 1 REG C!							--- save sign+sep+digits byte
 	DUP BL AND IF LSP THEN					--- select leading zero suppression
	DUP $80 AND							--- signed?
 	  IF OVER 0<
 	    IF "-" ELSE "+" THEN
 	    0 REG C!
 	  THEN
 	(PRINTNUM)
	RADIX>
	;
{
pub .DP ( dblnum decimals --- )
 	DUP >L 1 SWAP FOR #10 * NEXT UM/MOD64
 	<D> $400A PRINTNUM
 	L> ?DUP IF "." EMIT 8<< $0A + PRINTNUM THEN
	;
}
pub PRINTDEC ( number n -- \ Print a formatted decimal number with at least n digits )
 	8<< $400A OR PRINTNUM
 	;
pub .DECX	4 PRINTDEC ;


pri .EMIT		'.' EMIT ;
pri ~1			DUP 24 >> 10 PRINTNUM 8<< ;
--- Print an IP style formatted number i.e. &192.168.0.16
pub PRINT&		'&' EMIT ~1 .EMIT ~1 .EMIT ~1 .EMIT ~1 DROP ;

pub .BIN16		$5002 PRINTNUM ;
pub .BIN32		L>W '%' EMIT .BIN16 '_' EMIT .BIN16 ;






pub ROUND ( n1 rounder -- n1rnd )
 	SWAP OVER U/MOD 				--- now round it off to the nearest 0.25MHZ
 	SWAP 2* 3RD => 1 AND + *
	;

pub /ROUND ( val1 divisor -- val2 	\ Scale down a value by a divisor but round it up
                                    \ if the remainder is => half the divisor
                                    \ Usage:4567 100 /ROUND . 46           )
   DUP >L U/MOD
   SWAP L> 2/ > IF 1+ THEN
   ;






pub Minsky ( xOld yOld step -- xNew yNew )
	  >L SWAP OVER IX SAR - SWAP ( xNew yOld )
	  OVER L> SAR + ( xNew yNew )
	;




pub .SPRS ( -- \ Dump the cog's SPRs with labels in both HEX and BINARY )
        16 0 DO CR I $1F0 + .W PRINT" : "
        I 5 * " IJMP3IRET3IJMP2IRET2IJMP1IRET1ADRA ADRB PTRA PTRB DIRA DIRB OUTA OUTB INA  INB  " + 5 CTYPE
        PRINT"  = $" I $1F0 + COG@ DUP $4810 PRINTNUM     DROP \ PRINT"    %" $5F02 .NUM
        LOOP
        ;
pub lsregs
 	PRINT"  COG #" COGID $0A PRINTNUM PRINT"  registers" .SPRS
	;




2 LONGS ports
2 LONGS dirs

pri .PIN 	IF "H" ELSE "L" THEN EMIT ;
pub .IO		IF PRINT"  out" ELSE PRINT"  inp" THEN ;
pri .PH		CR "+" EMIT "-" #26 EMITS "+" EMIT ;

pub PINLOAD? ( pin# -- flg \ check if a pin is pulled down, up or highZ = floating )
	DUP HIGH DUP FLOAT #50 FOR NEXT DUP PIN@		\ returned to low if pulled down
	0= "D" AND
	OVER LOW OVER FLOAT #50 FOR NEXT SWAP PIN@		\ returned to high if pulled up
	"U" AND OR
 	dirs @ DIRA COG! dirs 4+ @ DIRB COG!				\ restore pin directions
	DUP 0= IF DROP "~" THEN
	;


pub .PINLOAD	 	PINLOAD?  SPACE EMIT ;



{HELP lsio
List I/O pin states as input/output and whether the pin is connected to a pullup/pulldown or floating.
Even if it's an output it will test the loading so that if it is connected to an LED that is pulled up then
this would report as an output with pullup.

TF2# lsio  PORT PINS
+--------------------------------+
P00 inp H float ||       H inp P63
P01 inp H float ||       H inp P62
P02 inp H float || float H inp P61
P03 inp H float || float L out P60
P04 inp H float || float H out P59

}
pub BIT? ( addr bitpos -- flg )		DUP $1F AND MASK SWAP 5 >> 4* ROT + @ AND 0<> ;

pub lsio
	PRINT"  PORT PINS"
	.PH
	PA@ ports ! PB@ ports 4+ !
	DIRA COG@ dirs ! DIRB COG@ dirs 4+ !
	BL 0
	DO
	  CR PRINT" P" I $20A PRINTNUM 						--- display Port number
 	  dirs I BIT? .IO 				--- display inp or out
	  SPACE ports I BIT? .PIN 						--- display pin state H or L
 	  I .PINLOAD									--- display load as up/down/float
 	  PRINT"   || "								--- over to right hand section
--- RIGHT SIDE
	  #63 I - DUP #62 < IF .PINLOAD SPACE ELSE DROP 3 SPACES THEN
 	  ports #63 I - BIT? .PIN
	  dirs #63 I - BIT? .IO
	PRINT"  P"
	#63 I - $20A PRINTNUM
	LOOP
	.PH
	;




( I2C BUS )



#P35	== *SDA
#P60	== *SCL			--- clock shared with SPI

BYTE i2cflg

--- wait but timeout while busy
pub ?I2C	i2cflg C@ IF 1500 BEGIN 1- i2cflg C@ 0= OVER 0= OR UNTIL DROP i2cflg C~  THEN ;

pub <I2C
	?I2C
pub <I2C>	--- restart without checking busy
	*SDA FLOAT *SCL HIGH
	--- setup mask for CLOCK instruction
 	*SCL 25 COG!
	*SDA LOW 1 i2cflg C! *SCL LOW
	;


{ I2C STOP CONDITION also releases I2C lines
 SCL XX-------==
 SDA XX___----==
}
pub I2C>
	--- pull SDA high from low while clock high
	*SDA LOW *SCL HIGH ( 1 DROP ) *SDA HIGH
	--- free up I2C lines
 	*SDA FLOAT *SCL FLOAT
 	i2cflg C~						--- i2c bus free
	;;


pub I2C!? ( data -- flg )
	REV #24 >>
	*SDA DUP HIGH SWAP
	8 FOR SHROUT  CLOCK CLOCK  NEXT
	DROP DUP FLOAT						--- Float SDA
	CLOCK PIN@  CLOCK					--- ack clock
	;


pub I2C!			I2C!? DROP ;

pub ackI2C@ 	0
--- 25.5us @96MHz
--- Fetch a byte from the I2C bus - mirror ack signal 0 in = 0 out
pub I2C@	( ack -- data  )
	*SDA DUP FLOAT 0  ( ack iomask dat )
\	  8 FOR CLKIN CLOCK NEXT
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK

	--- make SDA an high output
	OVER HIGH
	--- clock out ack bit
	-ROT SWAP CLKOUT DROP CLOCK FLOAT
 	;

pub nakI2C@	TRUE I2C@ ;

{
' COGREG 25
clockpins       long 0                  ' I/O mask for CLOCK instruction
clkdly          long 0
}


pub I2CFAST	0
pri ~D		26 COGREG! ;
pub I2C100	CLKMHZ ~D ;
pub I2C400	CLKMHZ 12 / ~D ;

pub lsi2c	$100 0 DO <I2C I 1+ I2C!? 0= IF I .BYTE SPACE THEN 2 +LOOP I2C> ;
























(	*** RTC and TIMERS ***		)




( REAL-TIME CLOCK )

{ HELP TIMER ( <name> -- )
create a timer variable (replaces DOUBLE)
ms(4), alarm/mode(2), link(2), tid(1), nu(1), nu(2)
}
pre TIMER			( 4 ALIGNORG ) DATPTR W@ 16 ERASE 4 [C] LONGS ;


\ Define variables used by the background timer cog

PUBLIC
1 cword timers		--- link to timers - set to 1 as last
PRIVATE
byte tid

CLKFREQ #1000 / == ttint				\ define the timing constant ( writable constant )

( Background timer API )

{ New timer methods that allow modules to link their timers into the background countdown process
add a timer to the list of timers to countdown,
addr points to 2 longs, first is the timer, second is both the alarm word and the link word
last timer has a link word of 0
link->TIMER3->TIMER2->TIMER1->0
}
--- Set the timeout period in ms for this timer - link and init if not already set
pub TIMEOUT ( ms addr --  )
 	SWAP OVER ! --- set it and link it if it has not been linked yet
pri +TIMER ( addr -- )
	--- discard and ignore if already linked
 	DUP 8 + C@ tid C@ = IF DROP EXIT THEN
	--- set tid
 	tid C@ OVER 8 + C!
	--- link in new timer (first one is set to 1 )
   	timers W@ OVER 6 + W!
	--- save latest in timers
 	timers W!
	;

pub COUNTUP ( addr -- \ countup timer mode )
 	1 SWAP
	DUP +TIMER
pub ALARM ( pfa addr -- \ Set an alarm action to perform once timeout occurs )
	4+ W!
	;
pub TIMEOUT? ( addr -- flg \ check if this timer has timed out )
	@ 0=
	;

TIMER wdt
pub WATCHDOG ( ms -- )		wdt TIMEOUT ;




PUBLIC
long	runtime

PRIVATE
8 bytes rtcbuf

4 bytes @time
4 bytes @date
2 bytes @day


pri rtcbuf@	rtcbuf + C@ ;
pri rtcbuf!	rtcbuf + C! ;



--- I2C RTC DRIVERS ---

--- RTC I2C ADDRESS psuedo constant
pub @rtc		0 ;

--- selects type of I2C RTC chip used
--- DS3231 is fairly generic f
pub DS3231		$D0
pri =rtc		' @rtc C! ;
pub MCP79410	$DE =rtc ;
---  EEPROM of MCP79410 - access with RTC@/RTC!
pub RTCEE		$AE =rtc ;
pub NORTC		0 =rtc ;


--- Start and address RTC device
pri <RTC			I2C400 <I2C @rtc I2C! ;
--- restart and read RTC device
pri <RTC>			<I2C> @rtc 1+ I2C! ;

--- Read first 8 timekeeping bytes of RTC into rtcbuf
pub RDRTC
	@rtc 0EXIT <RTC 0 I2C! <RTC>
	  rtcbuf 8 ADO ackI2C@ I C! LOOP nakI2C@ DROP I2C>
	;

--- Write first 8 timekeeping bytes of RTC from rtcbuf
pub WRRTC
	@rtc 0EXIT <RTC 0 I2C!
	  rtcbuf 8 ADO IC@ I2C! LOOP I2C>
	;

pub RTC! ( byte addr -- )	<RTC I2C! I2C! I2C> ;

pub RTC@ ( addr -- byte )	<RTC I2C! <RTC> nakI2C@ I2C> ;
\ pub RTCW@ 					DUP RTC@ 8<< SWAP 1+ RTC@ + ;

--- Select RTC as a DUMP device - byte method only
pub RTC						DUMP: RTC@ RTC@ RTC@ ;

pub BCD>DEC ( bcd -- dec )	DUP >N SWAP 4 >> 10 * + ;

pub DEC>BCD ( dec -- bcd )	10 U/MOD 4 << + ;

--- read HHMMSS time in decimal format
pub TIME@ ( -- #hhmmss )
    @time @ 1000 /
    60 U/MOD ( sec x ) 60 U/MOD ( sec mins hrs ) 24 MOD 10000 * SWAP 100 * + +
    ;

--- split 6 digit decimal number into 3 two digit groups
pri HMS ( #xxyyzz -- zz yy xx )		100 U/MOD 100 U/MOD ;

--- read international date in decimal format
pub DATE@ ( -- #yymmdd )
	@date @ DUP 0= IF DROP 010101 THEN
	;

pub TIME! ( hh.mm.ss -- )
	0
--- write time/date in decimal format where d/t = 4 for date
pub DT! ( hh.mm.ss|yy.mm.dd d/t -- )
	@rtc
	IF
	  RDRTC
	  4 AND 2DUP @time + !
	  OVER HMS ( yymmdd n dd mm yy )
	  DEC>BCD 4TH 2+ rtcbuf!
	  DEC>BCD 3RD 1+ rtcbuf!
	  --- ensure some RTC devices have a 'RUN' bit set otherwised it is ignored.
          DEC>BCD $80 OR OVER rtcbuf!
	  WRRTC
	THEN
--- write soft time/date in decimal format where d/t = 4 for date
pub SDT! ( hh.mm.ss|yy.mm.dd d/t -- )
	4 AND DUP NOT
	  IF DROP HMS 60 * SWAP + 60 * + 1000 * 0 THEN
	@time + !  --- time stored in milliseconds
	;

pub DATE! ( yy.mm.dd -- )	4 DT! ;

--- Days of the week constants
PUBLIC
1 == MON
2 == TUE
3 == WED
4 == THU
5 == FRI
6 == SAT
7 == SUN

pub DAY@ ( -- day )			@day C@ 1 MAX ;

--- set DAY as in MON DAY etc
pub DAY ( day -- )
     DUP @day C!
     @rtc IF 3 rtcbuf@ 7 ANDN + 3 rtcbuf! WRRTC ELSE DROP THEN
     ;

pub .DAY ( n -- )	1 7 LIMIT 1-  3 * " MonTueWedThuFriSatSun" + 3 CTYPE ;

pub .TIME
     TIME@ ':'

pri .DTF ( value sep -- )
     SWAP #10 >RADIX <# # # OVER HOLD # # SWAP HOLD # # #> PRINT$ RADIX>
     ;

--- Print date in international format YYYY/MM/DD
pub .DATE        20 . DATE@ '/' .DTF ;

pub .ASMONTH ( index -- )
    >N 1- 3 * " JanFebMarAprMayJunJulAugSepOctNovDec" + 3 CTYPE
    ;


\ 8 cbytes tz$
8 bytes tz$

pub TZ ( str -- )	tz$ $! ; \ tz$ DUP 8 ESAVEB ;

" UTC " TZ

pub .DT		TIME@ DATE@ DAY@
( Tue, 03 Dec 2013 04:19:05 GMT )
pri .DTS ( time date day -- )
	.DAY ',' EMIT HMS
	SPACE ROT $420A PRINTNUM
	SPACE SWAP .ASMONTH SPACE
	DUP 100 < IF 2000 + THEN PRINT
	SPACE ':' .DTF SPACE tz$ PRINT$ CR
	;

{

TACHYON
1	== January
2	== February
3	== March
4	== April
5	== May
6	== June
7	== July
8	== August
9	== September
10	== October
11	== November
12	== December

pub am ;
pre pm			1200 + ;

pri SetClock		10000 * SWAP 100 * + + DATE! DAY 100 * TIME! ;
pre Monday, 1		DEFER SetClock ;
pre Tuesday, 2		DEFER SetClock ;
pre Wednesday, 3	DEFER SetClock ;
pre Thursday, 4		DEFER SetClock ;
pre Friday, 5		DEFER SetClock ;
pre Saturday, 6		DEFER SetClock ;
pre Sunday, 7		DEFER SetClock ;
END


5:29 pm
Monday, 23 October 2017



}


--- STAMP@ returns a 32-bit millisecond time + day of month in top 5-bits
pub STAMP@ ( --- dhmsc )	@time @ @day 1+ C@ 27 << + ;


--- read temperature from DS3231
pub 'C ( -- 'C*100 )		@rtc IF $12 RTC@ $11 RTC@ B>W 6 >> 25 * ELSE 0 THEN ;
pub 'F ( -- 'F*100 )		'C 9 5 */ 3200 + ;
pub .TEMP			'C <# # # '.' HOLD #S #> PRINT$ PRINT" 'C " ;

( TIMERS )
--- Maintain chained list of TIMERS
--- by default count down 32-bits to zero every millisecond if set
pri CountDown
	--- next timer
	timers W@
 	BEGIN
	  --- link to another timer?
 	  DUP $FF >
	WHILE
	  --- count up mode? (ALARM=1)
 	  DUP 4+ W@ 1 =
 	  IF
	    --- simple count up mode
 	    DUP ++
 	  ELSE --- count down if non-zero
 	    DUP @ ?DUP
 	    IF
	      --- decrement non-zero timer and udate
 	      1- DUP 3RD !
	        --- if now zero then execute valid alarm if set
 	        0= IF DUP 4+ W@ DUP 4 >>
 	          IF CALL ELSE DROP THEN
 	        THEN
 	    THEN
 	  THEN
	  --- follow link to next timer
 	  6 + W@
 	REPEAT
 	DROP
	;


{ DS3231 REGISTERS  --- typical arrangement of most RTCs with minor differences

	7	6	5	4	3	2	1	0
00	0	----10 seconds---	------ seconds ----------
01	0	----10 minutes---	------ minutes ----------
02	0	12/24	PM --------------- hours ----------------
03	0	0	0	0	0	----- day -------
04	0	0	--date---	---------- date ---------
05	cent	0	0	--------- month -----------------
06	--------- 10 year -------	-------- year -----------
0E	/eosc	bbsqw	conv	-	-	intcn	A2IE	A1IE
11	sign------------------ temperature msb ------------------
12	-- t lsb --

}
pub !RTC
	--- set some defaults in case hardware is not present
	010101 4 SDT! 0 0 SDT! MON @day C!
	--- skip if no hardware RTC has been set
	@rtc 0EXIT
	--- otherwise buffer current RTC readings
	RDRTC
	--- read hours and convert to minutes
	2 rtcbuf@ $3F AND BCD>DEC 60 *
	--- read minutes, acc and convert to seconds
	1 rtcbuf@ BCD>DEC + 60 *
	--- read seconds and acc
	0 rtcbuf@ $7F AND BCD>DEC +
	--- convert to millisec and update soft rtc
	1000 * @time !				--- resynch soft rtc
	--- read year and decimal shift 4 places
	6 rtcbuf@ BCD>DEC #10000 *
	--- read month and decimal shift 2 places and acc
	5 rtcbuf@ $1F AND BCD>DEC 1 12 LIMIT #100 * +
	--- read date and acc
	4 rtcbuf@ $3F AND BCD>DEC 1 31 LIMIT DUP @day 1+ C! +
	--- latch date
	@date !
	--- day
	3 rtcbuf@ 7 AND 1 MAX @day C!
	;



--- --- --- --- TIMERS --- --- --- ---


--- create a timer variable (replaces DOUBLE)
--- ms(4), alarm/mode(2), link(2), tid(1), nu(1), nu(2)
pre TIMER		#12 [C] BYTES ;


\ Define variables used by the background timer cog

\ LONG	runtime
BYTE	_seconds
BYTE	_minutes
BYTE	_hours
BYTE	_days
LONG	_date
\ WORD	timers				--- link to timers
\ BYTE	tid
\ 1 timers W!				--- last link

\ CLKFREQ #1000 / == ttint				\ define the timing constant ( writable constant )

( Background timer API )

{ New timer methods that allow modules to link their timers into the background countdown process
add a timer to the list of timers to countdown,
addr points to 2 longs, first is the timer, second is both the alarm word and the link word
last timer has a link word of 0
link->TIMER3->TIMER2->TIMER1->0
}
pri +TIMER ( addr -- )
 	DUP 8 + C@ tid C@ = IF DROP EXIT THEN --- discard and ignore if already linked
 	tid C@ OVER 8 + C! --- set tid
   	timers W@ OVER 6 + W! --- link in new timer (first one is set to 1 )
 	timers W! --- save latest in timers
	;
pub TIMEOUT ( ms addr -- \ Set the timeout period in ms for this timer - link and init if not already set )
 	SWAP OVER ! --- set it and link it if it has not been linked yet
	+TIMER
	;
pub ALARM ( pfa addr -- \ Set an alarm action to perform once timeout occurs )
	4+ W!
	;

pub COUNTUP ( addr -- \ countup timer mode )
 	1 SWAP ALARM
	;

--- check if this timer has timed out
pub TIMEOUT? ( addr -- flg  )
	@ 0=
	;


pub DAT>NAME ( adr -- nfa \ find the nfa else false )
	@NAMES 1+
	BEGIN
	  DUP NFA>CFA >PFA 4+ @ 3RD = IF NIP EXIT THEN
	  NFA>CFA 3 + DUP C@ 0=
 	UNTIL
	2DROP 0
	;



\ List the timers and their status
pub .TIMERS
      SPACE CLKFREQ ttint / PRINT" ticks = 1/" 0 PRINTDEC 3 SPACES PRINT" runtime = " runtime @ .DEC
 	timers W@
 	BEGIN
 	  DUP $FF >
 	WHILE
 	  CR DUP .W 	  PRINT" : "
	  DUP DAT>NAME DUP PRINT$ LEN$ #17 SWAP - SPACES
 	  DUP @ 6 PRINTDEC ." ms "
 	  ." =" DUP @ .L
 	  ."  L:" DUP 6 + W@ .W
	  SPACE DUP 4+ W@ IF ." ALARM=" DUP 4+ W@ CFA>NFA 1+ PRINT$ THEN
 	  6 + W@								--- fetch the link to the next timer
 	REPEAT
 	DROP
 	;


( WATCHDOG TIMER )
{
Watchdog timer, default action is to reboot, activate from application by specifying a timeout period:
#3000 WATCHDOG --- reload the watchdog timer, if not reloaded within 3 seconds it will reboot
OFF WATCHDOG --- disable watchdog
}

TIMER wdt
pub WATCHDOG ( ms -- )		wdt TIMEOUT ;


( TIMERS )
--- Maintain chained list of TIMERS by counting down 32-bits to zero every millisecond if set
pri CountDown
	timers W@ --- next timer
 	BEGIN
 	  DUP $FF > --- another timer?
	WHILE
 	  DUP 4+ W@ 1 = --- count up mode? (ALARM=1)
 	  IF --- count up mode
 	    DUP ++ --- count up without anything else
 	  ELSE --- count down mode
 	    DUP @ ?DUP --- non-zero?
 	    IF
 	      1- DUP 3RD ! --- decrement non-zero timer and udate
 	        0= IF DUP 4+ W@ DUP 4 >> --- if now zero then execute valid alarm if set
 	          IF CALL ELSE DROP THEN
 	        THEN
 	    THEN
 	  THEN
 	  6 + W@ --- follow link to next timer
 	REPEAT
 	DROP
	;

12 LONGS timerstk		--- allot space for timer data stack (typ. 4 levels)
WORD timerjob
pub TIMERJOB ( cfa -- )		BEGIN timerjob W@ 0= UNTIL timerjob W! ;

{
pub 1SECOND
	_seconds C++ _seconds C@ 60 =>
	  IF _seconds C~ _minutes C++ _minutes C@ 60 =>
	    IF _minutes C~ _hours C++ _hours C@ 24 =>
	      IF _hours C~ _days C++ _days C@ 7 =>
	        IF _days C~
		THEN
	      THEN
	    THEN
	  THEN
	;
pub HHMM@		_hours C@ 100 * _minutes C@ + ;
pub TIME@		HHMM@ 100 * _seconds C@ + ;
pub DATE@		_date @ ;
pub DATE!		_date ! ;
pub DAY@		_days C@ 1+ ;
pub .DAY		DAY@ 1- 3 * " MONTUEWEDTHUFRISATSUN " + 3 CTYPE ;
pub TIME! ( hhmmss -- )		DUP 100 U/MOD 100 U/MOD _hours C! _minutes C! _seconds C! ;

1	== MON
2	== TUE
3	== WED
4	== THU
5	== FRI
6	== SAT
7	== SUN

pub DAY			1- _days C! ;
pub .DT			.DAY SPACE HHMM@ .DEC ;
pub .TIME		_hours C@ 2 PRINTDEC ." :" _minutes C@ 2 PRINTDEC ." :" _seconds C@ 2 PRINTDEC ;
}

pub TIMERTASK ( DESC: Provide background timing functions including alarm actions on timeouts )
	timerjob W~
	--- reset timer chain
	1 timers W!
	--- timer boot id - if timer id is same as this then it has already been added since boot
 	3 tid C+!
	--- clear variables
	runtime ~ _seconds ~
	--- set the WAITCNT DELTA for every millisecond
	ttint DELTA
	--- disable watchdog but link it into the timer list
 	wdt 8 ERASE 0 wdt TIMEOUT
	--- set default watchdog behaviour
	' REBOOT wdt ALARM
	BEGIN
	  --- allow other cogs to get this cog to handle I/O inits etc
 	  timerjob W@ ?DUP IF CALL timerjob W~ THEN
 	  runtime ++
\	  runtime @ 1000 MOD 0= IF 1SECOND THEN
	  --- maintain the linked chain of countdown timers
 	  CountDown
	  --- synch to next heartbeat
	  WAITCNT
	AGAIN
	;


{
pub .POLL
 	CR PRINT" POLL:   "  keypoll W@ ?DUP IF CFA>NFA C@++ CTYPE THEN
 	CR
	;
}

--- EXTENDED KEY POLLING - UP TO 8 ENTRIES ---
16 BYTES polls

pub .POLLS
	8 0 DO I 2* polls + W@ ?DUP
	  IF CR PRINT" POLL #" I PRINT SPACE CFA>NFA 1+ PRINT$ THEN
	LOOP
	;

pub ?POLL
 	polls 8 ADO I 2* W@ ?DUP IF CALL THEN LOOP
 	;
pub +POLL ( cfa -- )
 	polls 8 ADO I 2* W@ 0= IF DUP I 2* W! LEAVE THEN LOOP DROP
 	' ?POLL keypoll W!
	;

pub !POLL
	polls 16 ERASE
	' ?POLL keypoll W!
	;



LONG ucon

: [CON		uemit @ ucon ! CON ;
: CON]		ucon @ uemit ! ;

: DEBUG		^D KEY! ;
: SECONDS	#1000 * ms ;

ALIAS SECONDS SECOND


pri (.MODS)
	BEGIN
 	  DUP C@
 	WHILE
 	  DUP C@ 4 > 								--- name must be longer than 4 chars
	  IF DUP C@ 3 - OVER + @ " .fth" @ = 				--- is the end of the name = ".fth" ?
 	    IF
 	      DUP NFA>CFA >PFA DUP >L CR .W PRINT" : "		--- print it's PFA
 	      DUP 1+ DUP PRINT$ LEN$ #20 SWAP - SPACES			--- display the module name and try to line up the description
 	      L> CALL								--- execute the .fth word to display it's message
	    THEN
	  THEN
 	  DUP C@ + 4 +
	REPEAT
	DROP
;
pub .MODULES
 	CR PRINT" MODULES LOADED: "
	@NAMES (.MODS)
	;

--- Quick Stats
pub Q
	CR "-" #80 EMITS
	CR PRINT" CODE MEMORY  @" HERE .ADDR PRINT"  for " HERE $1000 - $400A PRINTNUM
	CR PRINT" NAME MEMORY  @" @NAMES .ADDR PRINT"  for " NFA' NOTFOUND #12 + @NAMES - $400A PRINTNUM
	CR PRINT" DATA MEMORY  @" _datorg @ DUP .ADDR PRINT"  for "  DATPTR SWAP - $400A PRINTNUM
	CR PRINT" FREE MEMORY  = " @NAMES HERE - $400A PRINTNUM
pub ??
	CR .VER .MODULES .POLLS
	CR .DT
	CR "-" #80 EMITS
	;


pub END  ( -- \ denotes end of source code module, does some housekeeping )
 	ON ECHO  \ ]~
	CR CR .TIME ."   End of source code, "
	lines W@ .DEC ."  lines processed and "
	errors W@ DUP IF 7 EMIT THEN .DEC ."  errors found "
	CR ." Load time = " LAP .LAP
\	.MODULES
	2 flags CLR
	Q
	;









--- CVA9 MOTHERBOARD - SINGLE WS2812 - grb
long ledbuf
pub LED! ( color -- )		ledbuf ! 18 PIN ledbuf 1 WS2812 ;

LONG bootsig
pub BOOT
	RND bootsig !
	$2000 LED!
	RAM I2C400
	keypoll W~
\	!POLL
	' TIMERTASK 3 RUN
	??
	$200000 LED!
	;









(       DECOMPILER     )


BYTE ~x
BYTE ~i
WORD ~w
20 BYTES ~f


--- create a temporary dummy def so that we can find the CFAs for unnamed words
: T BEGIN $1234 $12345678 UNTIL uemit $0FF " STRING" ;
' T 16 + W@		--- address and read " string literals
' T 14 + W@		--- 9-bit literal
' T 12 + W@		--- register offset
' T 10 + W@		--- address and read UNTIL
' T 4 + W@		--- address and read a LONG literal
' T W@			--- address and read a WORD literal
FORGET T		--- discard temp def and now use parameters for constants
== (W)			--- 16-bit WORD
== (L)			--- 32-bit LONG
8>> == (IF)		--- IF or UNTIL branch
8>> == (R)		--- 8-bit register offset
9 >> == (S)		--- 9-bit literal
== (")



pri 'EMIT	''' EMIT ;
pri .D		SPACE '(' EMIT DUP . ')' EMIT SPACE DUP BL $7E WITHIN IF 'EMIT EMIT 'EMIT EMIT ELSE DROP THEN ;

pri .T		'"' EMIT SPACE 2+ DUP PRINT$ '"' EMIT DUP LEN$ 1+ + ;
pri INDENT	~i C@ 0 MAX SPACES ;
pri +~i	2 ~i C+! ;
pri -~i	~i C@ IF -2 ~i C+! THEN ;


--- add an IF branch to address so that indentation and a THEN can be added
pri +if ( addr -- )		~f BEGIN DUP W@ WHILE 2+ REPEAT W! ;
pri if? ( addr -- flg )
	~f BEGIN 2DUP W@ <> OVER W@ 0<> AND WHILE 2+ REPEAT
	DUP W@ ROT =
	  IF 0 OVER W! ELSE DROP 0 THEN
	;
pri fad? ( addr -- flg )	0 ~f 20 ADO OVER I W@ <= OR 2 +LOOP NIP ;

pri .W9
	~w W@ $1FF AND
	DUP $20 $7E WITHIN IF 'EMIT DUP EMIT 'EMIT SPACE THEN
	DUP '#' EMIT PRINT SPACE DUP 9 > IF .W ELSE DROP THEN 2+
	;

pri (SEE)
	DUP ~w W!
	DUP 1 AND OVER $3FF $FC00 WITHIN AND IF PRINT" GOTO " 1 ANDN DUP .W DUP fad? NOT IF ~x C~~ THEN THEN
	( pc code )
	SWITCH
	' (.") CASE PRINT" PRINT" .T BREAK
	(") CASE .T BREAK
	(W) CASE 2+ DUP W@ DUP .W .D 2+ BREAK
	(L) CASE 2+ DUP @ DUP .L .D 4+ BREAK
	~w W@ 9 >> (S) = IF .W9 BREAK

	' EXIT CASE DUP fad? NOT IF PRINT" ;" ~x C~~ ELSE PRINT" EXIT" THEN 2+ BREAK
---	decoded wordcodes $FC00->$FFFF
        SWITCH@ 8>> SWITCH
	(R) CASE PRINT" REG " ~w C@ .B 2+ BREAK
	(IF) CASE ~w C@ $80 AND 0=
	    IF
	      PRINT" IF " +~i
	      DUP 2+ ~w C@ 2* + DUP +if
	    ELSE
	      PRINT" UNTIL "
	      DUP 2+ ~w C@ $7F AND 2* -
	    THEN
	.W 2+ BREAK

---	default for anything else
	DUP W@ DUP $3FF > IF 1 ANDN THEN CFA>NFA ?DUP IF 1+ PRINT$ THEN 2+
;

pub SEE?
	BEGIN
	  ~x C~
	  2 ALIGN
	  DUP if? IF CR 11 SPACES -~i INDENT PRINT" THEN" THEN
	  CR DUP .W ." : "
	  DUP W@ .W SPACE INDENT
	  DUP W@ (SEE)
	  ~x C@ KEY OR
	  DUP fad? NOT AND
	UNTIL
	DROP
;
pre SEE
	~x 22 ERASE		--- clear all variables
	4 ~i C!
	[C] NFA' [C] GRAB
	?DUP
	IF
	  DUP C@++ + C@ BL AND IF PRINT"  IMMEDIATE" THEN
	  NFA>CFA >PFA
	  SEE?
	ELSE PRINT"  not found "
	THEN
	;



END

BOOT

